#ifndef _AGNIX_TIMERS_H_
#define _AGNIX_TIMERS_H_

#include <agnix/list.h>
#include <agnix/spinlock.h>
#include <asm/types.h>

#define TIMER_FLAG_ONESHOT	0x01
#define TIMER_FLAG_NORMAL	0x02
#define TIMER_FLAG_EXCLUSIVE	0x04

#define TIMER_MAX_PRIO		0x10
#define TIMER_PRIO_EXCLUSIVE	0x00
#define TIMER_PRIO_RT		0x01
#define TIMER_PRIO_NORMAL	0x02

struct timer_s {
    u32 timer_expire;
    void (*timer_function)(void *data);
    void *timer_data;
    int timer_owner;
    int timer_priority;
    int timer_flags;
    struct list_head timer_list;
};

/*struct timer_group_s {
    struct list_head list;
    spinlock_t lock;
    int priority;
};
*/
int register_timer(struct timer_s *timer);
int unregister_timer(int timerd);
int run_timers(void);

#endif
