/*
 * kernel_drivers/adi_char/terminal.c
 *
 * Copyright (c) 2003-2004 Lukasz Dembinski <dembol@linux.net>
 * All Rights Reserved
 * 
 * Date:	2004/01
 * Author: 	Lukasz Dembinski
 * Info:	terminal.c core file
 * Contact:	mailto: <dembol@linux.net>
 *
 */

#include <agnix/terminal.h>
#include <agnix/list.h>

LIST_HEAD(terminal_list);
LIST_HEAD(terminal_sys_list);

int terminal_nr = 0;

int get_free_terminal(void)
{
    return terminal_nr++;
}

void put_free_terminal(void)
{
}

int set_terminal_var(int term_nr, struct terminal_var_s *term_var)
{
    return 0;    
}

int register_terminal(struct terminal_s *term)
{
    term->term_nr = get_free_terminal();

    if (term->ops && term->ops->init)
	term->ops->init(term);

    list_add(&term->term_list, &terminal_list);

    return term->term_nr;
}

int register_sys_terminal(struct terminal_s *term)
{
    list_add(&term->term_list, &terminal_sys_list);

    return 0;
}

int register_terminal_driver(struct terminal_s *term, struct terminal_driver_s *term_driver)
{
    term->term_driver = term_driver;
    
    if (term_driver->ops && term_driver->ops->init)
	term_driver->ops->init();

    return 0;
}
