#include <agnix/agnix.h>
#include <agnix/timers.h>
#include <agnix/memory.h>
#include <agnix/spinlock.h>
#include <agnix/queues.h>
#include <agnix/list.h>
#include <agnix/spinlock.h>
#include <agnix/math64.h>
#include <asm/bitops.h>
#include <agnix/console.h>

#define MOD_NAME		"TIMERS: "
#define MAX_TIMER_SET_ENTRIES	256
#define MAX_TIMER_SETS		16

#define TIMER_SET_EXP_BIN(bits)	 	timer_set_exp_bin(bits)
#define TIMER_SET_EXP(bits)	 	(TIMER_SET_EXP_BIN(bits) * MAX_TIMER_SET_ENTRIES)
#define TIMER_SET_RATE(bits)	 	((TIMER_SET_EXP(bits + 1) - TIMER_SET_EXP(bits)) / MAX_TIMER_SET_ENTRIES)
#define TIMER_SET_INIT(nr)		timer_sets[nr].timer_set_expire_min  = TIMER_SET_EXP(nr);  \
					timer_sets[nr].timer_set_expire_rate = TIMER_SET_RATE(nr);

struct timer_set_entry_s {
    struct list_head timer_set_entry_list;
    spinlock_t timer_set_entry_lock;
};

struct timer_set_s {
    int timer_set_expire_min;
    int timer_set_expire_rate;
    struct timer_set_entry_s timer_set_entries[MAX_TIMER_SET_ENTRIES];
};

struct timer_set_s timer_sets[MAX_TIMER_SETS];

unsigned int timer_set_exp_bin(unsigned long x)
{
    if (x - 1 < 0)
	return 0;

    return (1 << (x - 1));
}

int timer_count = 0;
u32 timer_pending = 0;
int timer_queue_desc;

int get_free_timer(void)
{
    return timer_count++;
}

int put_free_timer(int timerd)
{
    return 0;
}

int register_timer(struct timer_s *timer)
{
    struct queue_entry_s *entry;
    int timer_desc;
    int idx;
    u32 flags;
    
    if ((timer_desc = get_free_timer()) < 0)
	return -1;

    idx = timer->timer_expire / MAX_TIMER_SET_ENTRIES;
    

//    spin_lock_irqsave(
    
//    entry = (struct queue_entry_s *)get_free_pages(0);
//    entry->queue_entry_data = (void *)timer;
//
//    queue_enqueue(timer_queue_desc, entry);

//    set_bit(timer_prio, (void *)&timer_pending);
//    spin_lock_irq(&timer_group[timer_prio].lock);
//    spin_unlock_irq(&timer_group[timer_prio].lock);

    return timer_desc;
}

int modify_timer(int timerd, struct timer_s *new_timer) 
{
    return 0;
}

int unregister_timer(int timerd)
{
    return 0;
}

int run_timers(void)
{
    struct queue_entry_s *entry;
    struct timer_s *timer;

    if (timer_pending == 0) {
	return -1;
    }

    return 0;
}

int timers_init(void)
{
    int i, j;

    printk(MOD_NAME "Initializing timers\n");

    for (i = 0; i < MAX_TIMER_SETS; i++) {
	TIMER_SET_INIT(i);

	for (j = 0; j < MAX_TIMER_SET_ENTRIES; j++) {
	    INIT_LIST_HEAD(&timer_sets[i].timer_set_entries[j].timer_set_entry_list);
	    spin_lock_init(&timer_sets[i].timer_set_entries[j].timer_set_entry_lock);
//	    timer_sets[i].timer_set_entries[j].queue_desc = register_queue(QUEUE_TYPE_FIFO, "timers_queue");
	}
    }

//    printk("max queue_desc = %d\n", timer_sets[i - 1].timer_set_entries[j - 1].queue_desc);
        
    return 0;
}
